/*global module:false*/
module.exports = function (grunt) {

    grunt.initConfig({
            pkg: grunt.file.readJSON('package.json'),
            meta:{
                src:'<%=pkg.main%>',
                specs:'test/*.js',
                vendors:['test/lib/underscore-1.3.1.js', 'test/lib/jquery-1.7.2.min.js', 'test/lib/backbone.js'],
                specs_css:'test/spec.css'
            },

            jshint:{
                options:{
                    "curly": false,
                    "eqnull": true,
                    "eqeqeq": true,
                    "undef": true
                },
                all: ['<%=meta.src%>']
            },
            uglify:{
                backbone_view_states:{
                    files:{
                        'dist/backbone-view-states-<%=pkg.version%>.min.js':['<%=meta.src%>']
                    }
                }
            },

            jasmine:{
               spec:{
                    src:'<%=meta.src%>',
                    options:{
                        vendor:'<%=meta.vendors%>',
                        specs:'test/*.js',
                        styles:'test/spec.css'
                    }
                },
                coverage:{
                    src:'<%=meta.src%>',
                    options:{
                        vendor:'<%=meta.vendors%>',
                        specs:'test/*.js',
                        styles:'test/spec.css',
                        template:require('grunt-template-jasmine-istanbul'),
                        templateOptions:{
                            coverage:'coverage/json/coverage.json',
                            report:[
                                {type:'html', options:{dir:'coverage/html'}},
                                {type:'text-summary'}
                            ]
                        }
                    }

                }
            },

            jsbeautifier:{
                files:["<%=meta.src%>","<%=meta.specs%>"]
            },

            copy: {
                main: {
                    src: '<%=meta.src%>',
                    dest: 'dist/backbone-view-states-<%=pkg.version%>.js'
                }
            }

        }
    );

    grunt.loadNpmTasks('grunt-contrib-uglify');
    grunt.loadNpmTasks('grunt-jsbeautifier');
    grunt.loadNpmTasks('grunt-contrib-jasmine');
    grunt.loadNpmTasks('grunt-contrib-jshint');
    grunt.loadNpmTasks('grunt-contrib-copy');

    grunt.registerTask('spec', ['jasmine:spec']);
    grunt.registerTask('build', ['jshint','jasmine:spec','copy','uglify']);
    grunt.registerTask('coverage', ['jasmine:coverage']);
    grunt.registerTask('format', 'jsbeautifier');
    grunt.registerTask('default', ['jshint','jasmine:spec']);
};